<%@ Language = VBSCRIPT %>
<% Option Explicit %>

<HTML>
<BODY>

<%
   '*************************************************
   'Display a calendar based upon the current date
   '*************************************************

   'To accomplish this, we need to perform a number of tasks.
   'First, we will want to be able to determine the month name
   'for a given month.  So, let's create a function that
   'takes the numeric value of a month and displays the name of
   'the month (i.e., GetMonthName(8) would output August)
   Function GetMonthName(iMonth)
     Select Case iMonth
        Case 1:
          GetMonthName = "January"
        Case 2:
          GetMonthName = "February"
        Case 3:
          GetMonthName = "March"
        Case 4:
          GetMonthName = "April"
        Case 5:
          GetMonthName = "May"
        Case 6:
          GetMonthName = "June"
        Case 7:
          GetMonthName = "July"
        Case 8:
          GetMonthName = "August"
        Case 9:
          GetMonthName = "September"
        Case 10:
          GetMonthName = "October"
        Case 11:
          GetMonthName = "November"
        Case 12:
          GetMonthName = "December"
        Case Else:
          GetMonthName = "**INVALID MONTH**"
     End Select
   End Function


   'Next, we need to obtain the current
   'date.  To do this, we will store the result of the
   'Date() function into a variable named dbCurrentDate
   Dim dbCurrentDate
   dbCurrentDate = "1/1/2000"

   'Now, we need to display a calendar.  At most, a calendar
   'can have six weeks.  Since a week contains seven days,
   'we will show, at most, 42 calendar cells.  We will use
   'a TABLE to generate this calendar

   'We will create an array that will store the 42 possible
   'days of the month.
   Dim aCalendarDays(42)

   'Into aCalendarDays, we will place the days of the current
   'month.  We will use the DatePart function to determine
   'when the first day of the month is
   Dim iFirstWeekday
   iFirstWeekday = DatePart("w",DateSerial(Year(dbCurrentDate), Month(dbCurrentDate), 1))

   'Now, we want to loop from 1 to the number of days in the
   'current month, populating the array aCalendarDays
   Dim iDaysInMonth
   iDaysInMonth = DatePart("d",DateSerial(Year(dbCurrentDate), Month(dbCurrentDate)+1, 1-1))
   Dim iLoop
   For iLoop = 1 to iDaysInMonth
      aCalendarDays(iLoop + iFirstWeekday - 1) = iLoop
   Next


   'Now that we have our populated array, we need to display the
   'array in calendar form.  We will create a table of 7 columns,
   'one for each day of the week.  The number of rows we will use
   'will be 6, the total number of possible rows, minus 42 (the upper 
   'bound of the aCalendarDays array) minus the last array position
   'used (iFirstWeekday + iDaysInMonth) divided by seven, the number of
   'days in the week!  Simple, eh!!  :)
   Dim iColumns, iRows
   iColumns = 7
   iRows = 6 - Int((42 - (iFirstWeekDay + iDaysInMonth)) / 7)

   'Now, create the table
%>

   <TABLE ALIGN=CENTER BORDER=1 CELLSPACING=1 WIDTH=75% HEIGHT=75%>
     <TH COLSPAN=7>
        <FONT SIZE=+2>
<%
   'Display the month and year
   Response.Write GetMonthName(Month(dbCurrentDate))
   Response.Write ", " & Year(dbCurrentDate)
%>
        </FONT>
     </TH>
<%
   'Now, loop through 1 through iRows, then 1 through iColumns
   Dim iRowsLoop, iColumnsLoop
   For iRowsLoop = 1 to iRows
     'Create a new row
     Response.Write "<TR>"
     For iColumnsLoop = 1 to iColumns
       'Create a new column
       'If there is a day there, display it, else black out the cell
       If aCalendarDays((iRowsLoop-1)*7 + iColumnsLoop) > 0 then
         'Display the date
         Response.Write "<TD VALIGN=TOP ALIGN=RIGHT WIDTH=""14%"">"
         Response.Write aCalendarDays((iRowsLoop-1)*7 + iColumnsLoop)
         Response.Write "</TD>"
       Else
         'Black out the cell
         Response.Write "<TD BGCOLOR=BLACK>&nbsp;</TD>"
       End If
     Next

     'Close the row
     Response.Write "</TR>"
   Next
%>

   </TABLE>
</BODY>
</HTML>